import { Controller, NestInterceptor } from '@nestjs-client/common/interfaces';
import { ConfigurationProvider } from '@nestjs-client/common/interfaces/configuration-provider.interface';
import { ContextCreator } from '../helpers/context-creator';
import { NestContainer } from '../injector/container';
export declare class InterceptorsContextCreator extends ContextCreator {
    private readonly container;
    private readonly config;
    private moduleContext;
    constructor(container: NestContainer, config?: ConfigurationProvider);
    create(instance: Controller, callback: (...args) => any, module: string): NestInterceptor[];
    createConcreteContext<T extends any[], R extends any[]>(metadata: T): R;
    getInterceptorInstance(interceptor: Function | NestInterceptor): any;
    getInstanceByMetatype(metatype: any): {
        instance: any;
    } | undefined;
    getGlobalMetadata<T extends any[]>(): T;
}
