import { HttpServer, INestApplication, INestApplicationContext, INestMicroservice } from '@nestjs-client/common';
import { MicroserviceOptions } from '@nestjs-client/common/interfaces/microservices/microservice-configuration.interface';
import { NestMicroserviceOptions } from '@nestjs-client/common/interfaces/microservices/nest-microservice-options.interface';
import { NestApplicationContextOptions } from '@nestjs-client/common/interfaces/nest-application-context-options.interface';
import { NestApplicationOptions } from '@nestjs-client/common/interfaces/nest-application-options.interface';
import { INestExpressApplication } from '@nestjs-client/common/interfaces/nest-express-application.interface';
export declare class NestFactoryStatic {
    private readonly logger;
    /**
     * Creates an instance of the NestApplication
     * @returns {Promise}
     */
    create(module: any, options?: NestApplicationOptions): Promise<INestApplication & INestExpressApplication>;
    create(module: any, httpServer: HttpServer | any, options?: NestApplicationOptions): Promise<INestApplication & INestExpressApplication>;
    /**
     * Creates an instance of the NestMicroservice
     *
     * @param  {} module Entry (root) application module class
     * @param  {NestMicroserviceOptions & MicroserviceOptions} options Optional microservice configuration
     * @returns {Promise}
     */
    createMicroservice(module: any, options?: NestMicroserviceOptions & MicroserviceOptions): Promise<INestMicroservice>;
    /**
     * Creates an instance of the NestApplicationContext
     *
     * @param  {} module Entry (root) application module class
     * @param  {NestApplicationContextOptions} options Optional Nest application configuration
     * @returns {Promise}
     */
    createApplicationContext(module: any, options?: NestApplicationContextOptions): Promise<INestApplicationContext>;
    private createNestInstance<T>(instance);
    private initialize(module, container, config?, httpServer?);
    private createProxy(target);
    private createExceptionProxy();
    private applyLogger(options);
}
export declare const NestFactory: NestFactoryStatic;
