"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs-client/common");
const load_package_util_1 = require("@nestjs-client/common/utils/load-package.util");
const core_1 = require("@nestjs-client/core");
const express_adapter_1 = require("@nestjs-client/core/adapters/express-adapter");
const express_factory_1 = require("@nestjs-client/core/adapters/express-factory");
class TestingModule extends core_1.NestApplicationContext {
    constructor(container, scope, contextModule, applicationConfig) {
        super(container, scope, contextModule);
        this.applicationConfig = applicationConfig;
    }
    createNestApplication(httpServer = express_factory_1.ExpressFactory.create(), options) {
        httpServer = this.applyExpressAdapter(httpServer);
        this.applyLogger(options);
        this.container.setApplicationRef(httpServer);
        return new core_1.NestApplication(this.container, httpServer, this.applicationConfig, options);
    }
    createNestMicroservice(options) {
        const { NestMicroservice } = load_package_util_1.loadPackage('@nestjs-client/microservices', 'TestingModule');
        this.applyLogger(options);
        return new NestMicroservice(this.container, options, this.applicationConfig);
    }
    applyExpressAdapter(httpAdapter) {
        const isAdapter = httpAdapter.getHttpServer;
        if (isAdapter) {
            return httpAdapter;
        }
        return new express_adapter_1.ExpressAdapter(httpAdapter);
    }
    applyLogger(options) {
        if (!options || !options.logger) {
            return undefined;
        }
        common_1.Logger.overrideLogger(options.logger);
    }
}
exports.TestingModule = TestingModule;
